/*
 * OLSR ad-hoc routing table management protocol
 * Copyright (C) 2004 Andreas Tnnesen (andreto@ifi.uio.no)
 *
 * This file is part of olsrd-unik.
 *
 * UniK olsrd is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * UniK olsrd is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with olsrd-unik; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _BUILD_MSG_H
#define _BUILD_MSG_H

#include "packet.h"
#include "olsr_protocol.h"

void
hello_build(struct hello_message *, struct interface *);

void
tc_build(struct tc_message *, struct interface *);

int
mid_build(struct interface *);

void
hna_build(struct interface *);


/* IPv4 */

void
hello_build4(struct hello_message *, struct interface *);

void
tc_build4(struct tc_message *, struct interface *);

int
mid_build4(struct interface *);

void
hna_build4(struct interface *);

/* IPv6 */

void
hello_build6(struct hello_message *, struct interface *);

void
tc_build6(struct tc_message *, struct interface *);

int
mid_build6(struct interface *);

void
hna_build6(struct interface *);



#endif
